-- author Plutot
--
-- ver. 1.0
--

OpenCloseDoor = {};

function OpenCloseDoor.prerequisitesPresent(specializations)
	return true;
end;

function OpenCloseDoor:load(savegame)
  
  self.leftDoorAnimation = getXMLString(self.xmlFile, "vehicle.openCloseDoor.leftDoor#animName");
  self.rearWindowAnimation = getXMLString(self.xmlFile, "vehicle.openCloseDoor.rearWindow#animName");
  self.rightDoorAnimation = getXMLString(self.xmlFile, "vehicle.openCloseDoor.rightDoor#animName");
  
	if self.leftDoorAnimation ~= nil and self.rearWindowAnimation ~= nil and self.rightDoorAnimation ~= nil then
		self.openCloseDoor_initalized = true;
	else
		self.openCloseDoor_initalized = false;
	end;

end;

function OpenCloseDoor:postLoad(savegame)
end;

function OpenCloseDoor:getSaveAttributesAndNodes(nodeIdent)
end;

function OpenCloseDoor:delete()
end;

function OpenCloseDoor:readStream(streamId, connection)
end;

function OpenCloseDoor:writeStream(streamId, connection)
end;

function OpenCloseDoor:mouseEvent(posX, posY, isDown, isUp, button)
end;

function OpenCloseDoor:keyEvent(unicode, sym, modifier, isDown)
end;

function OpenCloseDoor:update(dt)

  if self.openCloseDoor_initalized and self.isEntered then
  
    local currentAnimation = nil;
    local currentState = nil;
    local currentFlag = nil;
  
    if InputBinding.isPressed(InputBinding.DOOR_LEFT) then
      currentAnimation = self.leftDoorAnimation;
      currentState = "leftDoor";     
    end;

    if InputBinding.isPressed(InputBinding.WINDOW_REAR) then
      currentAnimation = self.rearWindowAnimation;
      currentState = "rearWindow";
    end;

    if InputBinding.isPressed(InputBinding.DOOR_RIGHT) then      
      currentAnimation = self.rightDoorAnimation;
      currentState = "rightDoor";
    end;
    
    if currentAnimation ~= nil then 
      local currentAnimTime = Utils.clamp(self:getAnimationTime(currentAnimation), 0, 1);
            
      if currentAnimTime == 0 then 
        self:playAnimation(currentAnimation , 1, 0, true);        
        currentFlag = true;
      elseif currentAnimTime == 1 then
        self:playAnimation(currentAnimation , -1, 1, true);
        currentFlag = false;
      end;
      
      if currentState == "leftDoor" then
        self.leftDoorState = currentFlag;
      end;
      if currentState == "rearWindow" then
        self.rearWindowState = currentFlag;
      end;
      if currentState == "rightDoor" then
        self.rightDoorState = currentFlag;
      end;
    end;                  
  end;

end;

function OpenCloseDoor:draw()
end;
